{{
        Octave Drop on the Propeller
        
        Jonathan "lonesock" Dummer

        Configured for the Test Proto Board
}}

CON
  ' Configured for the Demo Board
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

  adc_in       = 8             ' mic sense
  adc_out      = 9             ' mic w/ resistor
  dacR          = 10            ' headphones' Left
  dacL          = 11            ' ditto but Right
     
  ' serial pins
  term_RX       = 31
  term_TX       = 30
  term_bps      = 460_800 ' 460_800, 115_200

  sr            = 44_100        ' let's run at the CD sampling rate

  
OBJ
  adc:          "IntADC"
  term:         "FFDS1"

  
' super quick and ugly demo
PUB test_IntADC : t | volume, sample, last

  ' The simplest DAC in the world
  volume := 0
  ctra_val := constant(%00111 << 26) | dacL | (dacR << 9)
  drive_mask := |<dacL | |<dacR
  cognew( @TrackDAC_pasm, @volume )

  ' Start the analog audio in  
  adc.start_freq( adc_in, adc_out, sr, @sample ) {
  ' OR do a simple sine test
  last := sample := |<26
  repeat
    t := (sample << 1) - (sample ~> 7) - last
    last := sample
    sample := t
  ' END Sine Test }
                         
  ' Start the serial link after the 2 audio drivers
  if ina[term_RX]
    ' the RX pin is high, so there is probably power to the FTDI chip
    term.start( term_RX, term_TX, term_bps )
  else
    ' just RX, since the FTDI is probably unpowered
    term.start( term_RX, -1, term_bps )

  ' does the user want to change the volume?
  repeat    
    t := term.rx
    if "0" == t
      volume := 0
    if "+" == t
      volume := (volume + 1) <# 0 ' was 31, but you can kill your ears!!
    if "-" == t
      volume := (volume - 1) #> -31
    term.str( string( 13, "The volume is now " ) )
    term.dec( volume )

' simple audio out
DAT
org 0
TrackDAC_pasm ' Initialize hardware
              mov       ctra, ctra_val
              mov       frqa, midval
              mov       dira, drive_mask
              
main_loop     ' read the volume and sample
              mov       tmp, par
              rdlong    tmp_vol, tmp
              add       tmp, #4
              abs       tmp_vol, tmp_vol wc
              rdlong    tmp, tmp
              ' adjust the volume (by powers of 2)
        if_c  sar       tmp, tmp_vol
        if_nc shl       tmp, tmp_vol
              add       tmp, midval
              ' update the driver
              mov       frqa, tmp
              ' already rinsed, now repeat
              jmp       #main_loop
                                                       

{===== PASM Parameters =====}
drive_mask    long      0
ctra_val      long      0
midval        long      |<31
tmp           res       1
tmp_vol       res       1